Bug 1770162 - Review Request: python-molten - A minimal, extensible, fast and productive API framework
Summary: Review Request: python-molten - A minimal, extensible, fast and productive AP...
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: Unspecified
OS: Linux
unspecified
unspecified
Target Milestone: ---
Assignee: Jerry James
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2019-11-08 11:00 UTC by Anna Khaitovich
Modified: 2020-06-14 08:01 UTC (History)
2 users (show)

Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2020-06-14 08:01:54 UTC
Type: Bug
loganjerry: fedora-review+


Attachments (Terms of Use)

Comment 1 Anna Khaitovich 2019-11-08 12:41:11 UTC
COPR build url: https://copr.fedorainfracloud.org/coprs/akhaitov/python-molten/build/1088893/

Comment 2 Jerry James 2019-11-15 20:20:46 UTC
I will take this review.  You mentioned on fedora-devel-list that you could swap reviews.  Would you mind looking at bug 1765731?  The subject matter is a bit esoteric, but the package itself is fairly simple, so I hope it doesn't present a problem for you.

Comment 3 Jerry James 2019-11-15 20:31:34 UTC
The binary package is not installable, because the automatic Requires generator generates this dependency:

python3.8dist(typing-inspect) < 0.4

due to this part of setup.py:

dependencies = [
    "typing-extensions>=3.6,<4.0",
    "typing-inspect>=0.3.1,<0.4",
]

The version reviewed in bug 1768490 is 0.5.  Does molten in fact work with typing-inspect >= 0.4?  If so, setup.py is wrong.  If not, then you'll either have to downgrade python-typing-inspect or figure out how to port molten to the 0.5 release.

Comment 4 Anna Khaitovich 2019-11-18 16:47:04 UTC
I've filed an issue upstream to remove this dependency - https://github.com/Bogdanp/molten/issues/35

For now, I've added this workaround to .spec to %prep section:

sed -i 's/\"typing-inspect>=0.3.1,<.*/"typing-inspect>=0.3.1"/' setup.py

I tried out running a few examples from upstream and looks like molten does indeed work with typing-inspect-0.5. 

Spec: https://copr-be.cloud.fedoraproject.org/results/akhaitov/python-molten/fedora-rawhide-x86_64/01088893-python-molten/python-molten.spec
SRPM: https://copr-be.cloud.fedoraproject.org/results/akhaitov/python-molten/fedora-rawhide-x86_64/01088893-python-molten/python-molten-0.7.4-1.fc32.src.rpm
COPR build: https://copr-be.cloud.fedoraproject.org/results/akhaitov/python-molten/fedora-rawhide-x86_64/01088893-python-molten/

Comment 5 Jerry James 2019-11-21 18:12:47 UTC
The spec file in comment 4 does not have the sed command.  I think you meant copr build 01112672 instead, right?  I'll review that one.

Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated

Issues
======

1. This is not really an issue.  I just wanted to point out that you can use
   this URL to get a source tarball with a name in it:

   Source0: %{url}/archive/v%{version}/%{pypi_name}-%{version}.tar.gz

   See https://fedoraproject.org/wiki/Packaging:SourceURL#Git_Tags.

2. The License file must be included with the %license macro.  Add this to the
   %files section:

   %license COPYING.LESSER

   The question in my mind is whether it should be:

   %license COPYING COPYING.LESSER

   Why did upstream include a copy of the GPL in COPYING if the project is
   licensed under the LGPL?  Is there something in the archive that is licensed
   with the GPL?

3. This part of %prep is not necessary:

   # Remove bundled egg-info
   rm -rf %{pypi_name}.egg-info

   The guidelines require that binary eggs be removed in %prep, but (a) this
   directory does not exist in the upstream tarball and (b) even if it did
   exist, it would be egg metadata, not a binary egg.

4. These manually specified dependencies:

   Requires:       python3dist(typing-extensions) < 4.0
   Requires:       python3dist(typing-extensions) >= 3.6
   Requires:       python3dist(typing-inspect) >= 0.3.1

   are redundant with the automatically generated dependencies; see the Requires
   section below.  Note the duplication.  You can remove the Requires lines from
   your spec file.


===== MUST items =====

Generic:
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[!]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: License field in the package spec file matches the actual license.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Package is not known to require an ExcludeArch tag.
[x]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 10240 bytes in 1 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: No rpmlint messages.
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package must not depend on deprecated() packages.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

Python:
[x]: Binary eggs must be removed in %prep
[x]: Python eggs must not download any dependencies during the build
     process.
[x]: A package which is used by another package via an egg interface should
     provide egg info.
[x]: Package meets the Packaging Guidelines::Python
[x]: Package contains BR: python2-devel or python3-devel
[x]: Packages MUST NOT have dependencies (either build-time or runtime) on
     packages named with the unversioned python- prefix unless no properly
     versioned package exists. Dependencies on Python packages instead MUST
     use names beginning with python2- or python3- as appropriate.
[x]: Python packages must not contain %{pythonX_site(lib|arch)}/* in %files

===== SHOULD items =====

Generic:
[x]: Reviewer should test that the package builds in mock.
[-]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[?]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[-]: Sources are verified with gpgverify first in %prep if upstream
     publishes signatures.
     Note: gpgverify is not used.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[x]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: python3-molten-0.7.4-1.fc32.noarch.rpm
          python-molten-0.7.4-1.fc32.src.rpm
2 packages and 0 specfiles checked; 0 errors, 0 warnings.




Rpmlint (installed packages)
----------------------------
1 packages and 0 specfiles checked; 0 errors, 0 warnings.



Source checksums
----------------
https://github.com/Bogdanp/molten/archive/v0.7.4.tar.gz :
  CHECKSUM(SHA256) this package     : aad3846283bf0080d53801b877df2640c170807404c46b931fca7d818af05bc2
  CHECKSUM(SHA256) upstream package : aad3846283bf0080d53801b877df2640c170807404c46b931fca7d818af05bc2


Requires
--------
python3-molten (rpmlib, GLIBC filtered):
    python(abi) = 3.8
    python3.8dist(typing-extensions) >= 3.6
    python3.8dist(typing-extensions) < 4
    python3.8dist(typing-inspect) >= 0.3.1
    python3dist(typing-extensions) >= 3.6
    python3dist(typing-extensions) < 4.0
    python3dist(typing-inspect) >= 0.3.1



Provides
--------
python3-molten:
    python-molten = 0.7.4-1.fc32
    python3-molten = 0.7.4-1.fc32
    python3.8dist(molten) = 0.7.4
    python3dist(molten) = 0.7.4



Generated by fedora-review 0.7.3 (44b83c7) last change: 2019-09-18
Command line :/usr/bin/fedora-review --copr-build https://copr-be.cloud.fedoraproject.org/results/akhaitov/python-molten/fedora-rawhide-x86_64/01112672-python-molten/ -m fedora-rawhide-x86_64
Buildroot used: fedora-rawhide-x86_64
Active plugins: Python, Shell-api, Generic
Disabled plugins: R, Java, SugarActivity, Ruby, Perl, C/C++, fonts, Haskell, PHP, Ocaml
Disabled flags: EPEL6, EPEL7, DISTTAG, BATCH, EXARCH

Comment 6 Anna Khaitovich 2019-11-29 14:28:16 UTC
(In reply to Jerry James from comment #5)

> 1. This is not really an issue.  I just wanted to point out that you can use
>    this URL to get a source tarball with a name in it:
> 
>    Source0: %{url}/archive/v%{version}/%{pypi_name}-%{version}.tar.gz
> 
>    See https://fedoraproject.org/wiki/Packaging:SourceURL#Git_Tags.
I tried to use the URL you suggested, but the tarball which is accessible by that URL has different contents - it has no tests, so I decided to go with the one that's been used in .spec

> 2. The License file must be included with the %license macro.  Add this to
> the
>    %files section:
> 
>    %license COPYING.LESSER
> 
>    The question in my mind is whether it should be:
> 
>    %license COPYING COPYING.LESSER
> 
>    Why did upstream include a copy of the GPL in COPYING if the project is
>    licensed under the LGPL?  Is there something in the archive that is
>    licensed with the GPL?
I'm not sure why, but since I didn't find any source files that'd be licensed under GPL, I decided to not include COPYING file. LGPL license (COPYING.LESSER) has been included.

> 3. This part of %prep is not necessary:
> 
>    # Remove bundled egg-info
>    rm -rf %{pypi_name}.egg-info
> 
This should be removed now.

> 4. These manually specified dependencies:
> 
>    Requires:       python3dist(typing-extensions) < 4.0
>    Requires:       python3dist(typing-extensions) >= 3.6
>    Requires:       python3dist(typing-inspect) >= 0.3.1
> 
>    are redundant with the automatically generated dependencies; see the
> Requires
>    section below.  Note the duplication.  You can remove the Requires lines
> from
>    your spec file.
This should also be removed.

New URLs:
Spec: https://copr-be.cloud.fedoraproject.org/results/akhaitov/python-molten/fedora-rawhide-x86_64/01120554-python-molten/python-molten.spec
SRPM: https://copr-be.cloud.fedoraproject.org/results/akhaitov/python-molten/fedora-rawhide-x86_64/01120554-python-molten/python-molten-0.7.4-1.fc32.src.rpm

Comment 7 Jerry James 2019-12-01 16:19:06 UTC
(In reply to Anna Khaitovich from comment #6)
> I tried to use the URL you suggested, but the tarball which is accessible by
> that URL has different contents - it has no tests, so I decided to go with
> the one that's been used in .spec

Interesting.  I expected them to be the same.  Okay, your approach is reasonable.  This package is APPROVED.

Comment 8 Gwyn Ciesla 2019-12-06 15:50:33 UTC
(fedscm-admin):  The Pagure repository was created at https://src.fedoraproject.org/rpms/python-molten

Comment 9 Mattia Verga 2020-06-14 08:01:54 UTC
This package was approved and imported in repositories, but this review ticket was never closed.
I'm closing it now.


Note You need to log in before you can comment on or make changes to this bug.